<!doctype html>
<html>
<head>
  <link rel="stylesheet" href="file:///android_asset/style.css" />
</head>
  <body>
  <h2>Premier projet</h2>
Le premier projet est détaillé selon les quatres aspects suivants :
<ul>
  <li>Création</li>
  <li>Arborescence</li>
  <li>Fichiers clés</li>
  <li>Déploiement</li>
</ul>
<h3>Création</h3>
<p>Ici, il est indiqué comment créer un premier projet avec l’utilitaire <i>Android
Studio</i>. Cependant, il est également possible de créer un projet en ligne de commande.

<ol>
<li>Créez un nouveau Projet d’Application Android (<i>Start a new Android Studio project</i>).</li>
<li>Laissez vous guider par l’utilitaire, Voici un exemple de configuration d’un projet :<br>
’Application name’ MyFirstApp,<br>
’Company Domain (Package name)’ chillcoding.com,<br>
Cochez Include Kotlin support;<br>
Puis Next;<br>
Cochez ’Phone and Tablet’ avec en version minimum supportée : API 15 : Android 4.0,<br>
Puis sélectionnez Next; Finish.</li>
<li>Vous avez la possibilité de choisir un modèle d’activité, choisissez
<code>Empty Activity</code> pour ce premier projet.</li>
<li>Remarquez le nom proposé par défaut pour une Activity <code>MainActivity</code>,
c’est l’une des conventions de nommage adopté par les développeurs Android.</li>
</ol>
</p>
<p><i>Android Studio</i> génére tous les éléments nécéssaires à un projet <i>Android</i>,
lors de la création du projet, cela peut prendre du temps. Il vous faudra explorer
votre projet afin de vous familiariser avec un <code>package</code>, une
<code>Activity</code>, un fichier XML, etc.</p>

<h3>Arborescence</h3>
<p>
app/<br>
-manifests<br>
-java<br>
-res<br>
--drawable<br>
--layout<br>
--values<br>
--menu<br>
Gradle Scripts<br>
</p>

<p>Ici, il vous est proposé d’explorer l’arborescence d’un projet à travers l'exercice :
« Exploration de l’arborescence d’un projet »<br>
Temps : 1 heure<br>
Dificulté : ∗<br>
<ol>
  <li>Observez le contenu du dossier app/ : Manifest, java, res, graddle</li>
  <li>Remarquez le lien avec l’interface graphique, dans le fichiers
  <code>MainActivity.kt</code>.</li>
  <li>Quel fichier modifier pour changer le texte affiché à l’écran ? Modifiez
  pour afficher « Hello Kotlin ! ».</li>
  <li>Remplacez l’agencement principale (situé à la racine du fichier
activity_main.xml) ConstraintLayout par un LinearLayout.</li>
  <li>Quel fichier modifier pour ajouter des éléments graphiques à l’écran ?
  Ajoutez du texte.</li>
  <li>Dans le fichier des ressources relatif aux images, res/drawable, ajoutez une image de votre choix.</li>
  <li>Ajoutez l’image en dessous du texte.</li>
  <li>Personnalisez brièvement le logo, les couleurs de l’application.</li>
</ol>
</p>
<p>Remarques :
les fichiers XMLs placés dans le dossier layout/, peuvent être édités
manuellement ou bien avec l’éditeur graphique.
communément ces fichiers XMLs, contiennent les éléments graphiques d’un écran
les dossiers drawable-ldpi (mdpi | hdpi) contiennent les images adaptés aux 3 types
d’écrans. Par exemple :
<ul>
  <li><i>hdpi</i> : images pour smartphone,</li>
  <li><i>xhdpi</i> : images pour tablette,</li>
  <li><i>mdpi</i> : images pour petit écran, lecteur mp3</li>
</ul></p>
<p>Note : Le fichier de projet <code>R</code> est un index contenant tous les
identifiants des ressources du projet. Il est automatiquement généré par
<i>Android Studio</i>.<br>
Cette classe est utilisée dans le code source comme référence vers les ressources
incluses dans le projet.</p>

<p>L’environnement de développement Android comprends un outil permettant à un
développeur graphiste, de designer un écran à partir de glisser/déposer
d’éléments graphiques classés dans une bibliothèque vers une maquette d’écran.
L’intérêt de la manipulation n’est pas seulement pour la conception mais aussi
pour le développement. En effet, l’outil génère du code xml.</p>

<h3>Fichiers clés</h3>
<p>Dans l'arborescence d'un projet, des fichiers et dossiers sont régulièrement visités :
 <ul>
  <li>Manifeste : Déclare les <i>Activity</i> et leur comportement</li>
  <li><code>java/</code> : le dossier des fichiers source, code <i>Kotlin</i>
organisé dans des <code>package</code></li>
  <li><code>res/</code> : le dossier des ressources</li>
  <li><code>drawable/</code> : le dossier des images</li>
  <li><code>mipmap/</code> : le dossier des icônes</li>
  <li><code>layout/</code> : le dossier des interfaces graphiques</li>
  <li><code>values/</code> : le dossier des variables couleur, chaine de caractères,
dimension, style, ...</li>
  <li><code>gen/R</code> : fichier généré</li>
  <li><code>Gradle Scripts</code> : contient deux fichiers de configurations
l'un pour le projet, l'autre pour le module <code>app/</code></li>
</ul>
</p>
<h3>Déploiement</h3>

<p>Le déploiement d’une application peut se faire soit sur émulateur, soit sur
appareil <i>Android</i>.</p>
<h5>Émulateur</h5>
<ol>
  <li>Ouvrez l’Android Virtual Device Manager (AVD Manager) en cliquant sur
l’icône représentant un smartphone.</li>
  <li>Faite Create Virtual Device, pour créer un nouvel émulateur.</li>
  <li>Choisissez un modèle de téléphone en fonction de votre résolution
d’ordinateur, par exemple le Nexus.</li>
  <li>Sélectionnez un System Image, gardez celui recommandé, par exemple
API 27.</li>
  <li>Nommez le, par exemple, MyNexus.</li>
  <li>Vérifiez les autres champs, et cliquez ok.</li>
  <li>Dans la fenêtre AVD Manager, sélectionnez l’avd créé (MyNexus), pour le lancer cliquez sur l’icône play.</li>
 </ol>
<p>Remarque : le lancement de l’émulateur prend quelques minutes. Vous pouvez
le laisser ouvert durant toute la séance et le fermer seulement quand vous avez
terminé de développer. Le fermer après chaque test d’application reviendrait
à éteindre votre téléphone après l’utilisation d’une application...</p>
<h5>Appareil Android</h5>
<p>Le déploiement d’une application Android sur un support consiste à installer
un fichier .APK (acronyme de Android PacKage) sur un support donné. Un fichier
.APK pour un téléphone Android est ce qu’est un .EXE pour un PC, un .DMG pour
un Mac OS X, un .APP pour un smartphone iOS, etc.</p>
<p>Habituellement, l’installation d’une application Android se fait via
l’<i>Android Market</i> ou le <i>Play Store</i>, dernièrement le <i>Google Play</i>.
Cependant, pour des applications Bêta ou underground il n’est pas possible de
passer par la voie normale où l’installation de l’application se fait de manière
invisible pour l’utilisateur. Ce qui suit décrit comment installer manuellement
une application, cela se fait en 2 étapes :
<ul>
  <li>autoriser les sources inconnus sur le support (attention à n’installer que
des applications de confiance)</li>
  <li>télécharger l’application sur le support via le cloud ou via câble USB</li>
</ul></p>
<p>Il est également possible d’exécuter l’application d’un projet Android Studio
directement sur un appareil <i>Android</i>, il suffit d’autoriser le
debuggage USB sur ce dernier et d’installer les drivers sur le PC.</p>
<ol>
<li>Sur le téléphone, allez dans Menu>Paramètres>Application>Développement et cochez Débogage USB.</li>
<li>Branchez le téléphone à votre ordinateur via le cable USB.</li>
<li>A présent, vous pouvez directement exécuter votre projet via <i>Android Studio</i>,
sur votre téléphone.</li>
<li>Ou bien, vous pouvez installer manuellement, une application tiers dont vous
détenez le .APK :<br>
Sur le téléphone, en sélectionnant dans la barre de notification
Connecté avec un câble USB, puis Activer le périphérique de stockage.<br>
Sur votre ordinateur, identifiez l’emplacement du .APK :<br>
/Development/MyApps/MyFirstApp/app/build/intermediates/instant- run-apk/debug</li>
 <li>Enfin déplacer le .APK depuis l’ordinateur.</li>
</ol>

<p>Finalement, dans ce thème «ABC d'Android», la plateforme Android a été introduite,
l'environnement de développement a été installé, les principes de programmation on
été envisagés et un premier projet a été créé.</p>
<cite>« Tout seul on va plus vite,
ensemble on va plus loin. »</cite>
<br>-> proverbe africain
  </body>
</html>
